package org.nuiton.topiatest;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;
import org.apache.commons.lang.builder.ToStringBuilder;

public  class CompanyDTO implements Serializable {

    public String name;
    public int siret;
    public EmployeDTO[] employe;
    public BillDTO[] storeBill;
    public DepartmentDTO[] department;
    protected final PropertyChangeSupport p = new PropertyChangeSupport(this);

     /**
      * addPropertyChangeListener :
      * @param listener 
      */
    public void addPropertyChangeListener(PropertyChangeListener listener) {
        p.addPropertyChangeListener(listener);
    }

     /**
      * addPropertyChangeListener :
      * @param propertyName 
      * @param listener 
      */
    public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        p.addPropertyChangeListener(propertyName, listener);
    }

     /**
      * removePropertyChangeListener :
      * @param listener 
      */
    public void removePropertyChangeListener(PropertyChangeListener listener) {
        p.removePropertyChangeListener(listener);
    }

     /**
      * removePropertyChangeListener :
      * @param propertyName 
      * @param listener 
      */
    public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        p.removePropertyChangeListener(propertyName, listener);
    }

     /**
      * setName :
      * @param value 
      */
    public void setName(String value) {
        java.lang.String oldValue = this.name;
        this.name = value;
        p.firePropertyChange("name", oldValue, value);
    }

     /**
      * getName :
      * @return String 
      */
    public String getName() {
        return name;
    }

     /**
      * setSiret :
      * @param value 
      */
    public void setSiret(int value) {
        int oldValue = this.siret;
        this.siret = value;
        p.firePropertyChange("siret", oldValue, value);
    }

     /**
      * getSiret :
      * @return int 
      */
    public int getSiret() {
        return siret;
    }

     /**
      * setEmploye :
      * @param values 
      */
    public void setEmploye(EmployeDTO[] values) {
        org.nuiton.topiatest.EmployeDTO[] oldValues = this.employe;
        this.employe = values;
        p.firePropertyChange("employe", oldValues, values);
    }

     /**
      * getEmploye :
      * @return EmployeDTO[] 
      */
    public EmployeDTO[] getEmploye() {
        return employe;
    }

     /**
      * setStoreBill :
      * @param values 
      */
    public void setStoreBill(BillDTO[] values) {
        org.nuiton.topiatest.BillDTO[] oldValues = this.storeBill;
        this.storeBill = values;
        p.firePropertyChange("store", oldValues, values);
    }

     /**
      * getStoreBill :
      * @return BillDTO[] 
      */
    public BillDTO[] getStoreBill() {
        return this.storeBill;
    }

     /**
      * setDepartment :
      * @param values 
      */
    public void setDepartment(DepartmentDTO[] values) {
        org.nuiton.topiatest.DepartmentDTO[] oldValues = this.department;
        this.department = values;
        p.firePropertyChange("department", oldValues, values);
    }

     /**
      * getDepartment :
      * @return DepartmentDTO[] 
      */
    public DepartmentDTO[] getDepartment() {
        return department;
    }

     /**
      * toString :
      * @return String 
      */
    public String toString() {
        String result = new ToStringBuilder(this).
            append("name", this.name).
            append("siret", this.siret).
            append("employe", this.employe).
         toString();
        return result;
}


} //CompanyDTO
