package org.nuiton.topiatest;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.nuiton.topiatest.deletetest.Party2DTO;

public  class PersonneDTO extends Party2DTO implements Serializable {

    public String name;
    public String[] otherNames;
    public Gender gender;
    public Gender otherGender;
    public AddressDTO address;
    public Title[] title;
    protected final PropertyChangeSupport p = new PropertyChangeSupport(this);

     /**
      * addPropertyChangeListener :
      * @param listener 
      */
    public void addPropertyChangeListener(PropertyChangeListener listener) {
        p.addPropertyChangeListener(listener);
    }

     /**
      * addPropertyChangeListener :
      * @param propertyName 
      * @param listener 
      */
    public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        p.addPropertyChangeListener(propertyName, listener);
    }

     /**
      * removePropertyChangeListener :
      * @param listener 
      */
    public void removePropertyChangeListener(PropertyChangeListener listener) {
        p.removePropertyChangeListener(listener);
    }

     /**
      * removePropertyChangeListener :
      * @param propertyName 
      * @param listener 
      */
    public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        p.removePropertyChangeListener(propertyName, listener);
    }

     /**
      * setName :
      * @param value 
      */
    public void setName(String value) {
        java.lang.String oldValue = this.name;
        this.name = value;
        p.firePropertyChange("name", oldValue, value);
    }

     /**
      * getName :
      * @return String 
      */
    public String getName() {
        return name;
    }

     /**
      * setOtherNames :
      * @param values 
      */
    public void setOtherNames(String[] values) {
        java.lang.String[] oldValues = this.otherNames;
        this.otherNames = values;
        p.firePropertyChange("otherNames", oldValues, values);
    }

     /**
      * getOtherNames :
      * @return String[] 
      */
    public String[] getOtherNames() {
        return otherNames;
    }

     /**
      * setGender :
      * @param value 
      */
    public void setGender(Gender value) {
        org.nuiton.topiatest.Gender oldValue = this.gender;
        this.gender = value;
        p.firePropertyChange("gender", oldValue, value);
    }

     /**
      * getGender :
      * @return Gender 
      */
    public Gender getGender() {
        return gender;
    }

     /**
      * setOtherGender :
      * @param value 
      */
    public void setOtherGender(Gender value) {
        org.nuiton.topiatest.Gender oldValue = this.otherGender;
        this.otherGender = value;
        p.firePropertyChange("otherGender", oldValue, value);
    }

     /**
      * getOtherGender :
      * @return Gender 
      */
    public Gender getOtherGender() {
        return otherGender;
    }

     /**
      * setAddress :
      * @param value 
      */
    public void setAddress(AddressDTO value) {
        org.nuiton.topiatest.AddressDTO oldValue = this.address;
        this.address = value;
        p.firePropertyChange("address", oldValue, value);
    }

     /**
      * getAddress :
      * @return AddressDTO 
      */
    public AddressDTO getAddress() {
        return address;
    }

     /**
      * setTitle :
      * @param values 
      */
    public void setTitle(Title[] values) {
        org.nuiton.topiatest.Title[] oldValues = this.title;
        this.title = values;
        p.firePropertyChange("title", oldValues, values);
    }

     /**
      * getTitle :
      * @return Title[] 
      */
    public Title[] getTitle() {
        return title;
    }

     /**
      * toString :
      * @return String 
      */
    public String toString() {
        String result = new ToStringBuilder(this).
            append("name", this.name).
            append("otherNames", this.otherNames).
            append("gender", this.gender).
            append("otherGender", this.otherGender).
            append("address", this.address).
            append("title", this.title).
         toString();
        return result;
}


} //PersonneDTO
